// dxf.h: interface for the dxf class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DXF_H__B8040031_F6BD_4F19_A9AD_2897275C0344__INCLUDED_)
#define AFX_DXF_H__B8040031_F6BD_4F19_A9AD_2897275C0344__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "init.h"				// zakladne nastavenia a zakladne hlavickove subory
#include <math.h>				// matematicka kniznica
#include <vector>
#include "load_texture.h"
using namespace std;

#define MAX_LEVEL 150

struct face4
{
	XYZ		v[4];
	XYZ		n;
};

struct face3
{
	XYZ		v[3];
	
};

struct Slevel
{
	vector<face4>	face;
	unsigned int	num_face;
	char	name[30];
	unsigned int texture;
	float	color[4];
	bool	texturing;
};

class dxf  
{
	Slevel	level[MAX_LEVEL];
	FILE*	sub;
	char	t[100];
	int		c;
public:
	void Render_normals(void);
	void Render_visible_line(float dx,float dy,float dz);
	void Render_line(void);
	void Render(int texturing=1);
	void LoadFace(void);
	float Float(void);
	void Int(void);
	void String(void);
	dxf(char* file_name);
	dxf();
	~dxf();

	unsigned int Textura(unsigned int poradie)
	{
		if(poradie>=MAX_LEVEL)return 0;
		return level[poradie].texture;
	}

};

#endif // !defined(AFX_DXF_H__B8040031_F6BD_4F19_A9AD_2897275C0344__INCLUDED_)
