//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////

#include "scene.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
scene::scene()
{
	int i;
	//////////////////////////////////////
	// smerniky na instancie na triedy nastavim na NULL, aby som ich potom nemazal
	font0 = NULL;
	c = NULL;
	_6kriz = NULL;
	for(i=0; i<4; i++)mnohosten[i]=NULL;
	steny = NULL;
	cajnik = NULL;
	//////////////////////////////////////
	// textury
	glass=0; zdroj_svetla=0;
	//////////////////////////////////////
	// prepinace
	svetlo=0; texturovanie=1; ciary=0;

	fps = 200.f;							// v pripade ze nieco zavisy od fps

	// zistime ci je mozne pouzit rozsirenie orezanie hrany pri texturovani
	char *extensions;
	extensions=strdup((char *) glGetString(GL_EXTENSIONS));			// Fetch Extension String
	int len=strlen(extensions);
	for ( i=0; i<len; i++)										// Separate It By Newline Instead Of Blank
		if (extensions[i]==' ') extensions[i]='\n';
	if( isInString(extensions,"GL_SGIS_texture_edge_clamp") ||
		isInString(extensions,"GL_SGI_texture_edge_clamp") ||
		isInString(extensions,"GL_EXT_texture_edge_clamp") )edge_clamp_supported=1;
	else edge_clamp_supported=0;

	//////////////////////////////////////
	// nacitanie textur

	i=0;
	if( !LoadTexture("stained.bmp",	&glass) ) {error = 1;return;}
	if( !LoadTexture("svetlo.jpg",	&zdroj_svetla) ) {error = 1;return;}

	//////////////////////////////////////
	// vytvarame instancie pouzivanych tried
	font0 = new Font("data/font.bmp",&error);		// vytvorenie fontu
	c = new Camera;
	_6kriz = new dxf("data/6kriz.dxf");
	mnohosten[0] = new dxf("data/Tetrahedron_4.dxf");
	mnohosten[1] = new dxf("data/Hexahedron_6.dxf");
	mnohosten[2] = new dxf("data/Octahedron_8.dxf");
	mnohosten[3] = new dxf("data/Icosahedron_20.dxf");
	steny = new dxf("data/steny.dxf");

	cajnik = new C3ds("data/teapot.3ds");
	if(error)return;

	InitGL();									// nastavenie z-buffra,svetla,...
	//ShowCursor(0);

	c->MoveWorld(fps);
	glGetFloatv( GL_MODELVIEW_MATRIX, &mat_glass.m[0][0] );
	mat_glass = invert( mat_glass);
	dist_glass = (float )sqrt(c->vp.x * c->vp.x + c->vp.y * c->vp.y + c->vp.z * c->vp.z);
	
	float k = 0.08f*dist_glass;
	vertex_glass[0].x = c->vp.x + k*c->vd.x - 0.4f*c->vr.x - 0.4f*c->vu.x;
	vertex_glass[0].y = c->vp.y + k*c->vd.y - 0.4f*c->vr.y - 0.4f*c->vu.y;
	vertex_glass[0].z = c->vp.z + k*c->vd.z - 0.4f*c->vr.z - 0.4f*c->vu.z;
	
	vertex_glass[1].x = c->vp.x + k*c->vd.x + 0.4f*c->vr.x - 0.4f*c->vu.x;
	vertex_glass[1].y = c->vp.y + k*c->vd.y + 0.4f*c->vr.y - 0.4f*c->vu.y;
	vertex_glass[1].z = c->vp.z + k*c->vd.z + 0.4f*c->vr.z - 0.4f*c->vu.z;
	
	vertex_glass[2].x = c->vp.x + k*c->vd.x + 0.4f*c->vr.x + 0.4f*c->vu.x;
	vertex_glass[2].y = c->vp.y + k*c->vd.y + 0.4f*c->vr.y + 0.4f*c->vu.y;
	vertex_glass[2].z = c->vp.z + k*c->vd.z + 0.4f*c->vr.z + 0.4f*c->vu.z;
	
	vertex_glass[3].x = c->vp.x + k*c->vd.x - 0.4f*c->vr.x + 0.4f*c->vu.x;
	vertex_glass[3].y = c->vp.y + k*c->vd.y - 0.4f*c->vr.y + 0.4f*c->vu.y;
	vertex_glass[3].z = c->vp.z + k*c->vd.z - 0.4f*c->vr.z + 0.4f*c->vu.z;

	zdroj[0].x = c->vp.x - 0.2f*c->vr.x - 0.2f*c->vu.x;
	zdroj[0].y = c->vp.y - 0.2f*c->vr.y - 0.2f*c->vu.y;
	zdroj[0].z = c->vp.z - 0.2f*c->vr.z - 0.2f*c->vu.z;
	
	zdroj[1].x = c->vp.x + 0.2f*c->vr.x - 0.2f*c->vu.x;
	zdroj[1].y = c->vp.y + 0.2f*c->vr.y - 0.2f*c->vu.y;
	zdroj[1].z = c->vp.z + 0.2f*c->vr.z - 0.2f*c->vu.z;
	
	zdroj[2].x = c->vp.x + 0.2f*c->vr.x + 0.2f*c->vu.x;
	zdroj[2].y = c->vp.y + 0.2f*c->vr.y + 0.2f*c->vu.y;
	zdroj[2].z = c->vp.z + 0.2f*c->vr.z + 0.2f*c->vu.z;
	
	zdroj[3].x = c->vp.x - 0.2f*c->vr.x + 0.2f*c->vu.x;
	zdroj[3].y = c->vp.y - 0.2f*c->vr.y + 0.2f*c->vu.y;
	zdroj[3].z = c->vp.z - 0.2f*c->vr.z + 0.2f*c->vu.z;

	light_glass[0] = c->vp.x;
	light_glass[1] = c->vp.y;
	light_glass[2] = c->vp.z;
	light_glass[3] = 1;

	c->vp.z = 14.f;
}

scene::~scene()
{
	int i;
	//////////////////////////////////////
	// mazeme instancie tried
	if(font0!=NULL)delete font0;
	if(c!=NULL)delete c;
	if(_6kriz!=NULL)delete _6kriz;
	if(steny!=NULL)delete steny;
	if(cajnik!=NULL)delete cajnik;
	for(i=0; i<4; i++)if(mnohosten[i]!=NULL)delete mnohosten[i];
	//////////////////////////////////////
	// mazeme textury
	glDeleteTextures( 1, &glass);
	glDeleteTextures( 1, &zdroj_svetla);

	KillGL();
	ShowCursor(1);
}

void scene::InitGL(void)
{
	if(!fullscreen)
	{
		RECT		WindowRect;					// miesto pre velkost okna
		WindowRect.left=(long)0;
		WindowRect.top=(long)0;
		GetClientRect(hWnd,&WindowRect);				//zistenie rozmerov uzivatelskej casti okna
		ReSizeGLScene(WindowRect.right,WindowRect.bottom);	//nastavenie perspektivy
	}
	else ReSizeGLScene(screen_x, screen_y);	//definovana v tomto subore

	glEnable(GL_TEXTURE_2D);		// Povolenie zobrazovanie textr
	glShadeModel(GL_SMOOTH);		/*nastavuje tienovanie
	GL_SMOOTH - objekty su tienovane t.j. prechody medzi farbami bodov su plinule (gouradovo (s)tienovanie)
	GL_FLAT   - objekty nie su tienovane ziadne plinule prechody */

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f); //specifikuje hodnoty na cistenie pomocou glClear par.: red, green, blue, alpha (cierny podklad)
	glClearDepth(1.0f);  //specifikuje hodnoty na cistenie pomocou glClear par.: depth (hlbka)
	
	/* ZAPNUTIE HLBKOVEHO TESTU */
	glEnable(GL_DEPTH_TEST);		// zapne hbkov test
	glDepthFunc(GL_LEQUAL);			// typ hbkovho testu
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);	// relnejie perspektvne vpoty
	
	GLfloat LightAmbient[]	=	{ 0.2f, 0.2f, 0.2f, 1.0f };		//svetlo ktore osvetluje zo vsetkych stran rovnako (okolite svetlo)
	GLfloat LightDiffuse[]	=	{ 1.0f, 1.0f, 1.0f, 1.0f };		//smerove, alebo bodove svetlo - svetlo svieti z pozicie zadanej pomocou premennej LightPosition
	GLfloat LightPosition[4]=	{ 0.0f, 0.0f, 1.0f, 0.0f };	//smer difuzneho svetla - ak je 4 zlozka 0 - smerove svetlo, ak nie je 0 potom s jedna o bodove svetlo so suradnicami x,y,z
	
	glLightModelfv ( GL_LIGHT_MODEL_AMBIENT, LightAmbient );	// nastavenie okoliteho (Ambient) svetla
	glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );			// nastavenie difuzneho svetla
	glLightfv ( GL_LIGHT0, GL_POSITION, LightPosition  );		// pozicia difuzneho svetla
	glEnable  ( GL_LIGHT0 );									// aktivovanie svetla 0
	
	GLfloat mat_diffuse[]	= { 1.0f, 1.0f, 1.0f, 1.0f };
	GLfloat mat_specular[]	= { 0.9f, 0.9f, 0.9f, 1.0f };
	GLfloat mat_shininess[] = { 128.0f };

	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE , mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);

	glColor3f(1.0f,1.0f,1.0f);				// biela farba	
}

void scene::KillGL()
{
}

void scene::Kurzor(void)			// zisti poziciu mysi a zobrazy kurzor
{
/*	GetCursorPos(&MouseBod);		//nacitanie pozicie mysi
	glBegin(GL_LINES);
		glVertex2i(MouseBod.x+velkost_kurzoru+1,screen_y-1-MouseBod.y);
		glVertex2i(MouseBod.x-velkost_kurzoru+1,screen_y-1-MouseBod.y);
		glVertex2i(MouseBod.x+1,screen_y-1-MouseBod.y+velkost_kurzoru);
		glVertex2i(MouseBod.x+1,screen_y-1-MouseBod.y-velkost_kurzoru);
	glEnd();
*/
	glBegin(GL_LINES);
		glVertex2i(mouse_x+velkost_kurzoru+1,mouse_y);
		glVertex2i(mouse_x-velkost_kurzoru+1,mouse_y);
		glVertex2i(mouse_x+1,mouse_y+velkost_kurzoru);
		glVertex2i(mouse_x+1,mouse_y-velkost_kurzoru);
	glEnd();
}

void scene::ReSizeGLScene(int width, int height)
{
	sirka = width;
	vyska = height;
	ReSizeGLScene_3D(width, height);
}

void scene::ReSizeGLScene_3D(int width, int height)		// funkcia pre zmenu velkosti okna
{										// vola sa v pripade zmeny velkosti okna, zmenu z(na) fullscreen
	if (height==0) height=1;
	glViewport(0,0,width,height);		// Viewport (pohlad)
	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	gluPerspective(uhol_kamery,(GLfloat)width/(GLfloat)height,blizka_orezavacia_rovina,vzdialena_orezavacia_rovina);
	/* gluPerspective - nastavuje perspektivu kamery, ako bude vypadat priestor z pohladu kamery.
	1. parameter urcuje zorn uhol kamery. 2.param. - gldAspect je pomer vky a rky zobrazovanej plochy.
	3. par. udava vzdialenost od ktorej je vidiet vykreslovane objekty
	4. par. udava vzdialenost do ktorej je vidiet vykreslovane objekty */
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();					// Reset The Modelview Matrix
}

void scene::ReSizeGLScene_2D(int width, int height)		// funkcia pre zmenu velkosti okna
{
	if (height==0) height=1;
	glViewport(0,0,width,height);		// Viewport (pohlad)
	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	glOrtho(0,screen_x,0,screen_y,-1,1);	// nastavuje standardne pravouhle premietanie
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();					// Reset The Modelview Matrix
}

void scene::Prepni_do_3D(void)			// rychle prepnutie do 3D
{
	glEnable(GL_DEPTH_TEST );

	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	gluPerspective(uhol_kamery,(float)sirka/(float)vyska,blizka_orezavacia_rovina,vzdialena_orezavacia_rovina);
	/* gluPerspective - nastavuje perspektivu kamery, ako bude vypadat priestor z pohladu kamery.
	1. parameter urcuje zorn uhol kamery. 2.param. - gldAspect je pomer vky a rky zobrazovanej plochy.
	3. par. udava vzdialenost od ktorej je vidiet vykreslovane objekty
	4. par. udava vzdialenost do ktorej je vidiet vykreslovane objekty */
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();
}

void scene::Prepni_do_2D(void)			// rychle prepnutie do 2D
{
	if(svetlo)glDisable(GL_LIGHTING);					// vypne svetlo
	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);	// vypne ciarovy rezim
	if(!texturovanie)glEnable(GL_TEXTURE_2D);			// zapne texturovanie
	glDisable(GL_DEPTH_TEST );

	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	glOrtho(0,screen_x,0,screen_y,-1,1);// nastavuje standardne pravouhle premietanie
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();					// Reset The Modelview Matrix
}

void scene::SaveScreen()
{
	FILE *sub;
	unsigned char* buf = new unsigned char[3*screen_x*screen_y];
	unsigned char* pom = new unsigned char[3*screen_x*screen_y];
	char file[30];

	if(buf==NULL || pom==NULL)
	{
		if(buf==NULL)delete[] buf;
		if(pom==NULL)delete[] pom;
		return;
	}

	glReadPixels(0, 0, screen_x, screen_y, GL_RGB, GL_UNSIGNED_BYTE, buf);
	for(int i=0; i<screen_y; i++)
	{
		for(int j=0; j<3*screen_x; j++)
		{
			pom[3*screen_x*(screen_y-i-1)+j] = buf[i*3*screen_x+j];
		}
	}
	delete[] buf;
	
	for(int c=0;c<99;c++)
	{
		char pom[20];
		strcpy(file,"screen");
		if(c<10)strcat(file,"0");
		strcat(file,itoa(c,pom,10));
		strcat(file,".raw");
		sub = fopen(file,"r");
		if(sub==NULL)c=100;
		if(sub!=NULL)fclose(sub);
	}
	
	sub = fopen(file,"w");
	fwrite(pom, 3*screen_x*screen_y, 1, sub);
	fclose(sub);
	delete[] pom;
}

bool scene::isInString(char *string, const char *search)
{
	int pos=0;
	int maxpos=strlen(search)-1;
	int len=strlen(string);	
	char *other;
	for (int i=0; i<len; i++) 
	{
		if ((i==0) || ((i>1) && string[i-1]=='\n')) 
		{							// New Extension Begins Here!
			other=&string[i];			
			pos=0;													// Begin New Search
			while (string[i]!='\n') 
			{														// Search Whole Extension-String
				if (string[i]==search[pos]) pos++;					// Next Position
				if ((pos>maxpos) && string[i+1]=='\n') return true; // We Have A Winner!
				i++;
			}			
		}
	}	
	return false;													// Sorry, Not Found!
}